'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _Sense = require('./abilities/senses/Sense');

var _Sense2 = _interopRequireDefault(_Sense);

var _playerObject = require('./decorators/playerObject');

var _playerObject2 = _interopRequireDefault(_playerObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var propertyBlacklist = ['_action', '_senses', 'constructor', '_addAction', '_addSense', 'action'];

var Turn = (_dec = (0, _playerObject2.default)(propertyBlacklist), _dec(_class = function () {
  function Turn(abilities) {
    var _this = this;

    _classCallCheck(this, Turn);

    this._action = null;
    this._senses = new Map();

    abilities.forEach(function (ability, name) {
      if (ability instanceof _Sense2.default) {
        _this._addSense(name, ability);
      } else {
        _this._addAction(name);
      }
    });
  }

  _createClass(Turn, [{
    key: '_addAction',
    value: function _addAction(name) {
      var _this2 = this;

      Object.defineProperty(this, name, {
        value: function value() {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          if (_this2.action) {
            throw new Error('Only one action can be performed per turn.');
          }

          _this2._action = [name, args];
        }
      });
    }
  }, {
    key: '_addSense',
    value: function _addSense(name, sense) {
      var _this3 = this;

      this._senses.set(name, sense);
      Object.defineProperty(this, name, {
        value: function value() {
          var _senses$get;

          return (_senses$get = _this3._senses.get(name)).perform.apply(_senses$get, arguments);
        }
      });
    }
  }, {
    key: 'action',
    get: function get() {
      return this._action;
    }
  }]);

  return Turn;
}()) || _class);
exports.default = Turn;